-- Init some colors
local white = Color.new(255, 255, 255)
local yellow = Color.new(255, 255, 0)
local red = Color.new(255, 0, 0)
local grey = Color.new(47, 47, 47)
local oldpad = SCE_CTRL_CROSS

-- List a directory
local scripts = System.listDirectory("ux0:/data/CAMERAPRO/")
local cur_dir = "ux0:/data/CAMERAPRO/"

local imgTmp = Graphics.loadImage("app0:/frames/tmp.png")
local header = Graphics.loadImage("app0:/gtop.png")
local footer = Graphics.loadImage("app0:/gbottom.png")
local btnBack = Graphics.loadImage("app0:/back.png")

-- Init a index
local i = 1

local delayTouch = 8.0

local previewImg = false

-- Main loop
while true do
	local x1,y1 = Controls.readTouch()
	
	if x1 ~= nil then
		-- Back button
		if x1>870 and y1>460 then
			if previewImg == false then
				Graphics.freeImage(imgTmp)
				Graphics.freeImage(header)
				Graphics.freeImage(footer)
				Graphics.freeImage(btnBack)
				break
			end
		end
	end
	if delayTouch>0 then 
		delayTouch = delayTouch - 0.1
	end
	-- Reset y axis for menu blending
	local y = 36
	
	-- Write title on screen
	Graphics.initBlend()
	Screen.clear()
	Graphics.fillRect(0, 960, 0, 544, grey)
	
	-- Write visible menu entries
	for j, file in pairs(scripts) do
		x = 5
		if j >= i and y < 960 then
			if i == j then
				color = red
				x = 10
			else
				color = white
			end
			Graphics.debugPrint(x, y, file.name, color)
			y = y + 20
		end
	end
	
	if #scripts>0 then
	Graphics.debugPrint(640, 320, "Image " .. i .. "/" .. #scripts, white)
	else
	Graphics.debugPrint(640, 320, "There are no images.", red)
	end
	
	Graphics.debugPrint(556, 360, "Pro Camera Vita v1.1 by VitaHEX\n  www.patreon.com/vitahex", white)
	--Draw thumbnail
	Graphics.drawScaleImage(454, 38, imgTmp, 0.5, 0.5)
	
	Graphics.drawImage(0, 0, header)
	Graphics.drawImage(0, 497, footer)
	Graphics.drawImage(882, 473, btnBack)
	if previewImg == true then
		Graphics.drawImage(0, 0, imgTmp)
	end
	
	Graphics.termBlend()
	
	-- Check for input
	pad = Controls.read()
	if Controls.check(pad, SCE_CTRL_CROSS) and not Controls.check(oldpad, SCE_CTRL_CROSS) then
		if previewImg == false and #scripts>0 then
			previewImg = true
			imgTmp = Graphics.loadImage(cur_dir .. scripts[i].name)
		end
	elseif Controls.check(pad, SCE_CTRL_CIRCLE) and not Controls.check(oldpad, SCE_CTRL_CIRCLE) then
		if previewImg == true then
			previewImg = false
			--Graphics.freeImage(imgTmp)
		end
	elseif Controls.check(pad, SCE_CTRL_TRIANGLE) and not Controls.check(oldpad, SCE_CTRL_TRIANGLE) then
		if previewImg == false and #scripts>0 and delayTouch<0.1 then
			delayTouch=4
			System.deleteFile(cur_dir .. scripts[i].name)
			dofile("app0:/gallery.lua")
		end
	elseif Controls.check(pad, SCE_CTRL_UP) and not Controls.check(oldpad, SCE_CTRL_UP) then
		if #scripts>0 then
		i = i - 1
		if i < 1 then
			i = #scripts
		end
			Graphics.freeImage(imgTmp)
			imgTmp = Graphics.loadImage(cur_dir .. scripts[i].name)
		end
	elseif Controls.check(pad, SCE_CTRL_DOWN) and not Controls.check(oldpad, SCE_CTRL_DOWN) then
		if #scripts>0 then
		i = i + 1
		if i > #scripts then
			i = 1
		end
			Graphics.freeImage(imgTmp)
			imgTmp = Graphics.loadImage(cur_dir .. scripts[i].name)
		end
	end
	
	-- Check for out of bounds in menu
	if i > #scripts then
		i = 1
	elseif i < 1 then
		i = #scripts
	end
	
	-- Update oldpad and flip screen
	oldpad = pad
	Screen.flip()
	
end
